



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>机器学习-支持向量机SVM</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">机器学习-支持向量机SVM</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-18 16:40:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h4>简介：</h4>
<p>支持向量机（SVM）是一种二分类的监督学习模型，他的基本模型是定义在特征空间上的间隔最大的线性模型。他与感知机的区别是，感知机只要找到可以将数据正确划分的超平面即可，而SVM需要找到间隔最大的超平面将数据划分开。所以感知机的超平面可以有无数个，但是SVM的超平面只有一个。此外，SVM在引入核函数之后可以处理非线性问题。</p>
<p>SVM根据数据的不同可以分为以下三种形式：</p>
<p>1.线性可分支持向量机，也叫做硬间隔支持向量机，处理的数据是线性可分的，通过硬间隔最大化来学习一个线性可分的模型。</p>
<p>2.线性支持向量机，也叫做软间隔支持向量机，当数据近似线性可分时，通过引入松弛因子，软间隔最大化学习一个线性可分的模型。</p>
<p>3.非线性支持向量机，当数据线性不可分时，通过引入核函数将数据映射到高维空间后，学习得到一个非线性支持向量机。</p>
<h4>线性可分支持向量机</h4>
<p>考虑一个二分类问题，当数据可以在分布空间中通过一个超平面将正负样例分割开，一面为正类，一面为负类，我们就称数据是线性可分，这个分离超平面的方程为：w*x+b=0。而在线性可分数据中存在着无数个超平面可以将数据分割开（参考感知机），我们要找到其中最好的超平面，这个超平面不仅可以将训练集数据很好的划分开，还有更好的泛化能力。下图中很显然直线B是最好的一条分割线，所以选择间隔最大的一个超平面作为我们需要的最优的超平面。</p>
<div><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/3395407-2a103a0d3f03b6e1.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>图1</div>
</div>
<p>求解超平面w*x+b=0就是求w和b，以及对应的分类决策函数f(x)=sign(w*x+b)，称之为线性可分支持向量机。</p>
<p>根据点到直线距离公式：</p>
<div><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/3395407-b624ef4c81d9a11b.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>图2</div>
</div>
<p>其中A为w向量，C为b，因为超平面的y值为0，所以对于支持向量机的点到超平面距离可以写作：</p>
<div><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/3395407-4fc7d4dfa5a486a7.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>图3</div>
</div>
<p>又因为w*x+b的边界为正负1，两个边界到超平面的距离和&gamma;等于2倍的r，所以图3又可以写作：</p>
<div><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/3395407-3921a557a85a3f5e.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>图4</div>
</div>
<p>这就是几何间隔。下图是支持向量机的各个概念图：</p>
<div><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/3395407-ea63ef50a6c17773.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>图5</div>
</div>
<p>当数据点为正类时，其y=+1，w*x+b&gt;=+1，当数据点为负类时y=-1，w*x+b&lt;=-1，所以y*(w*x+b)始终大于等于1，其中y*(w*x+b)成为函数间隔。</p>
<p>要找到间隔最大的超平面，也就是要找到满足y*(w*x+b)&gt;=1约束条件的参数w和b，使得&gamma;最大。即：</p>
<div><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/3395407-8a96e8825080653b.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>图6</div>
</div>
<p>显然为了最大化间隔，仅需最大化||w||，这等价于最小化||w||的2次方，所以可以重写为：</p>
<div><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/3395407-4d43e2cbe7b07157.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>图7</div>
</div>
<p>其中目标函数和约束函数都是连续可微的凸函数，并且目标函数是二次函数，约束函数是仿射函数，所以该约束问题是一个凸二次规划问题。</p>
<p>求解凸二次规划约束问题常用的办法是引入拉格朗日乘子，通过求解对偶问题得到原始问题的解。这就是线性可分支持向量机的对偶算法。</p>
<p>首先定义拉格朗日函数，对每个不等式约束引入拉格朗日乘子&alpha;i&gt;=0,i=1,2,3....n.拉格朗日函数为：</p>
<div><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/3395407-89916507165828c8.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>图8</div>
</div>
<p>这样就把带有约束问题的求极值问题转为无约束求极值问题，接下来根据拉格朗日对偶性求解原始问题的对偶问题：</p>
<div><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/3395407-5675c8508a8e4d25.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>图9</div>
</div>
<p>以上就是求解线性可分支持向量机的全部过程，求解得到w和b之后就可以得到分类超平面：</p>
<div><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/3395407-a5974836f03a7179.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>图10</div>
</div>
<p>以及分类决策函数：</p>
<div><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/3395407-a7885c80f25d84c4.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>图11</div>
</div>
<p>根据图9中w*和b*的结果可以看出，w*和b*只依赖于&alpha;i&gt;0对应的(xi，yi)样本点，这些样本点称为支持向量。</p>
<h4>线性支持向量机</h4>
<p>当数据近似线性可分时，也就是说数据中存在噪声点，我们通过引入松弛因子，使函数间隔加上松弛因子&xi;后大于等于1，这样约束条件就变成：</p>
<div><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/3395407-d04f9e5060d6a469.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>图12</div>
</div>
<p>对于每个松弛因子&xi;i需要支付一个代价，所以目标函数也就是代价函数变为：</p>
<div><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/3395407-5acce3c987d5c264.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>图13</div>
</div>
<p>其中C&gt;0称为惩罚参数，是超参数需要我们手动调参，C值越大时对误分类的惩罚增大，支持向量机的间隔宽度越窄，C值越小时对误分类的惩罚越小，支持向量机的间隔宽度越宽。而&xi;的几何意义代表着，误分类数据点离正确分类一侧的距离，是几何距离。</p>
<p>那么这个松弛因子&xi;是怎么来的呢？因为数据是近似可分的存在着许多噪音点，所以当计算代价函数时，这些误分类点要算入代价函数中去。这些误分类点的函数间隔y*(w*x+b)&lt;=-1，所以代价函数可以写成带有0/1损失函数的集合函数，就是当数据点的函数间隔减去1小于0的话(误分类点)，需要计算入代价函数，数据点的函数间隔减去1大于0的话(正确分类点)，不需要计算入代价函数：</p>
<div><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/3395407-ed59dc2e2ba9a31c.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>图14</div>
</div>
<p>但是0/1损失函数的数学性质不好，非凸非连续性。所以一般使用他的代替损失函数&ldquo;hinge损失max(0,1-z)&rdquo;代替它，则代价函数也就是目标函数变为：</p>
<div><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/3395407-fb6b38c47cd97a11.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>图15</div>
</div>
<p>用&xi;替代max部分，就是&xi;&lt;=1-y*(w*x+b)，所以带有约束条件的目标(代价)函数就变为下面的形式：</p>
<div><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/3395407-b4ce30107c098eeb.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>图16</div>
</div>
<p>所以SVM的损失函数也可以看作是带有L2正则项(||w||^2)的hinge损失函数。以上就是线性支持向量机的带有约束条件的优化目标函数，求解w和b的过程与线性可分的方法一致，都是通过引入拉格朗日乘子，这里不再重复。其中一些列需要满足的约束条件称为KKT条件。</p>
<h4>非线性支持向量机</h4>
<p>当数据样本非线性可分时，也就是在当前的数据空间内（或者说当前维度内）无法找到一个超平面将数据分割开，那么需要我们将数据从当前的维度映射到更高维度后，使数据变成线性可分的，而将数据映射到高维的函数称之为核函数。</p>
<p>为什么在SVM求解带有约束条件的最优化问题时我们使用引入拉格朗日乘子方法，一是因为求解简单，二是可以很方便的引入核函数K(x,z)。</p>
<p>通过引入核函数之后，对偶问题的目标函数就变成：</p>
<div><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/3395407-e8e2e7a27081d4bc.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>图17</div>
</div>
<p>最后求解出w*和b*之后的决策分类函数：</p>
<div><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/3395407-8f45db961d5985b3.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>图18</div>
</div>
<p>这样通过核函数的引入，可以用求解线性支持向量机的方法求解非线性支持向量机。学习是隐式的，不是了解核函数是如何计算以及数据到底被映射到哪一维空间的，但是需要我们手动的选择核函数。常用的核函数有：</p>
<p>多项式核：</p>
<div><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/3395407-e5b0c9ced4209931.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>图19</div>
</div>
<p>高斯核（径向基核）:</p>
<div><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/3395407-23ebe7e76461c914.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>图20</div>
</div>
<p>线性核，sigmoid核以及其他核函数等。通常使用先验知识或者交叉验证的方式选择核函数，但是如果无先验知识的情况下，一般选择高斯核。为什么选择高斯核呢？因为可以将数据映射到无穷维空间。</p>
<h4>SMO序列最小最优化</h4>
<p>该学习方法是为了简单求解SVM中的参数的一个算法，并不是很重要（调包侠^-^），所以没有很详细的看，以后有时间看完再更新到本文中。</p>
<p>待更新。。</p>
<p>参考书籍:</p>
<p>《统计学习方法》李航 著</p>
<p>《机器学习》 周志华&nbsp; 著</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1z3x29.html">IntelliJ IDEA 15，16 win 7 64位安装包以及注册码 百度云盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv2jgy9.html">【Win10 开发】读取PDF文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rmj2e8.html">SSLv3 Poodle攻击漏洞检测工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwpwpk8.html">Codeforces Round &num;333 &lpar;Div&period; 1&rpar; D&period; Acyclic Organic Compounds trie树合并</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vxj548.html">Linux Shell编程（9）&mdash;&mdash;特殊变量类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x4xo09.html">php拦截器&lpar;魔术方法&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm65509.html">linux服务器伪分布模式安装hadoop-1&period;1&period;2</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjle5y9.html">去除winXP访问共享的&OpenCurlyDoubleQuote;记住密码&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmg1169.html">php 查看文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zgy2n9.html">框架技术--Spring自动加载配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp0dx59.html">Acitivity的一些属性配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkke2z8.html">【DP&vert;多重背包可行性】POJ-1014 Dividing</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pm3ry8.html">HDU3371--Connect the Cities（最小生成树）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pde5od9.html">lvs&lowbar;nat</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1knz009.html">Apache、Lighttpd、Nginx 三种web服务器对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkjvg08.html">SpringBoot&colon; 配置加载顺序</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojrd25q.html">java判断A字符串是否包含B字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp6kwzq.html">ECC椭圆曲线以及计算出公钥的过程（BTC为例）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyydwrgq.html">leetcode 415 两个字符串相加</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5n77mq.html">SQL Server 一致性读</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxl2o6jq.html">springboot自定义异常页面</a>
			</li>
						<li><a href="https://www.batexi.com/a/9g3p5yzq.html">LightOJ 1203--Guarding Bananas&lpar;二维凸包&plus;内角计算&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qndnwo28.html">CentOS中的 yum upgrade 和 yum update 的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/q44p7d0q.html">jQuery基本toggle&lpar;&rpar; toggleClass&lpar;&rpar; 使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2xk6wv9.html">集合之HashMap、Hashtable</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e0mx0mq.html">mysql 库和表占用空间查询</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxl246zq.html">spark源码编译记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/q15vdn69.html">电子相册之bitmap</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kmoln69.html">Kylin 几个sql报错原因 汇总</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy2v32j9.html">使用cgroups来控制磁盘IO带宽</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
